Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- AccessorSynthesis
- CleanUp
- Constructors
- Delambdafy
- Erasure
- ExplicitOuter
- ExtensionMethods
- Fields
- Flatten
- InfoTransform
- LambdaLift
- Mixin
- OverridingPairs
- PostErasure
- SampleTransform
- SpecializeTypes
- Statics
- TailCalls
- Transform
- TypeAdaptingTransformer
- TypingTransformers
- UnCurry

c

scala.tools.nsc.transform

# Mixin 

###

#### abstract class Mixin extends SubComponent with InfoTransform with TreeDSL with AccessorSynthesis

Source
  Mixin.scala

Linear Supertypes
AccessorSynthesis, TreeDSL, InfoTransform, Transform, SubComponent, AnyRef, Any
Known Subclasses
mixer
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Mixin
2. AccessorSynthesis
3. TreeDSL
4. InfoTransform
5. Transform
6. SubComponent
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Mixin()

### Type Members

1.  abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent
2.  trait AccessorTreeSynthesis extends AnyRef
   Definition Classes
     AccessorSynthesis
3.  case class BitmapInfo (symbol: Global.Symbol, mask: Global.Literal) extends Product with Serializable
   Definition Classes
     AccessorSynthesis
4.  trait CheckInitAccessorSymbolSynth extends CheckedAccessorSymbolSynth
   Definition Classes
     AccessorSynthesis
5.  trait CheckedAccessorSymbolSynth extends AnyRef
   Definition Classes
     AccessorSynthesis
6.  trait CheckedAccessorTreeSynthesis extends AccessorTreeSynthesis
   Definition Classes
     AccessorSynthesis
7.  class Phase extends InfoTransform.Phase
   Definition Classes
     InfoTransform
8.  class MixinTransformer extends Global.Transformer with AccessorTreeSynthesis

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     TreeDSL
2.  abstract val runsAfter: List[String]

   Names of phases that must run before this phase.

   Names of phases that must run before this phase.

   Definition Classes
     SubComponent
3.  abstract val runsRightAfter: Option[String]

   Name of the phase that this phase must follow immediately.

   Name of the phase that this phase must follow immediately.

   Definition Classes
     SubComponent

### Concrete Value Members

1.  object CODE
   Definition Classes
     TreeDSL
2.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
3.  final def ##(): Int
   Definition Classes
     AnyRef → Any
4.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Mixin to any2stringadd[Mixin] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
5.  def ->[B](y: B): (Mixin, B)
   Implicit
     This member is added by an implicit conversion from Mixin to ArrowAssoc[Mixin] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
6.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
7.  val EmptyThicket: Global.EmptyTree.type
   Definition Classes
     AccessorSynthesis
8.  def Thicket(trees: List[Global.Tree]): Global.TermTree with Serializable
   Definition Classes
     AccessorSynthesis
9.  def addMember(clazz: Global.Symbol, member: Global.Symbol): Global.Symbol

   Add given member to given class, and mark member as mixed-in.

10.  def addMixedinMembers(clazz: Global.Symbol, unit: Global.CompilationUnit): Unit

    Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

    Add all members to be mixed in into a (non-trait-) class These are: for every mixin trait T that is not also inherited by the superclass: add late interface members to T and then:

    - if a member M of T is forwarded to the implementation class, add a forwarder for M unless one exists already. The alias of the forwarder is the static member it forwards to.
    - for every abstract accessor in T, add a field and an implementation for that accessor
    - for every super accessor in T, add an implementation of that accessor
    - for every module in T, add a module
11.  final def afterOwnPhase[T](op: ⇒ T): T
    Definition Classes
      SubComponent
    Annotations
      @inline()
12.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
13.  final def beforeOwnPhase[T](op: ⇒ T): T
    Definition Classes
      SubComponent
    Annotations
      @inline()
14.  def changesBaseClasses: Boolean
    Attributes
      protected
    Definition Classes
      InfoTransform
15.  def checkedAccessorSymbolSynth(clz: Global.Symbol): CheckedAccessorSymbolSynth
    Definition Classes
      AccessorSynthesis
16.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
17.  def cloneAndAddMember(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol
18.  def cloneBeforeErasure(mixinClass: Global.Symbol, mixinMember: Global.Symbol, clazz: Global.Symbol): Global.Symbol
19.  def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent
20.  def ensuring(cond: (Mixin) ⇒ Boolean, msg: ⇒ Any): Mixin
    Implicit
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
21.  def ensuring(cond: (Mixin) ⇒ Boolean): Mixin
    Implicit
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
22.  def ensuring(cond: Boolean, msg: ⇒ Any): Mixin
    Implicit
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
23.  def ensuring(cond: Boolean): Mixin
    Implicit
      This member is added by an implicit conversion from Mixin to Ensuring[Mixin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
24.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
25.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
26.  def explodeThicket(tree: Global.Tree): List[Global.Tree]
    Definition Classes
      AccessorSynthesis
27.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
28.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Mixin to StringFormat[Mixin] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
29.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
30.  def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    Definition Classes
      SubComponent → AnyRef → Any
31.  val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent
32.  val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent
33.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
34.  def isOverriddenAccessor(member: Global.Symbol, bcs: List[Global.Symbol]): Boolean

    Is member overridden (either directly or via a bridge) in base class sequence `bcs`?

35.  def keepsTypeParams: Boolean
    Attributes
      protected
    Definition Classes
      InfoTransform
36.  def mustExplodeThicket(tree: Global.Tree): Boolean
    Definition Classes
      AccessorSynthesis
37.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
38.  def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      InfoTransform → Transform → SubComponent
39.  def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Attributes
      protected
    Definition Classes
      Mixin → Transform
40.  final def notDeferred(sym: Global.Symbol): Boolean
    Annotations
      @inline()
41.  final def notify(): Unit
    Definition Classes
      AnyRef
42.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
43.  def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent
44.  val phaseName: String

    The name of the phase:

    The name of the phase:

    Definition Classes
      Mixin → SubComponent
45.  def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent
46.  def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent
47.  def publicizeTraitMethod(sym: Global.Symbol): Unit

    Some trait methods need to be implemented in subclasses, so they cannot be private.

    Some trait methods need to be implemented in subclasses, so they cannot be private.

    We used to publicize during explicitouter (for some reason), so the condition is a bit more involved now it's done here (need to exclude lambdaLIFTED methods, as they do no exist during explicitouter and thus did not need to be excluded...)

    They may be protected, now that traits are compiled 1:1 to interfaces. The same disclaimers about mapping Scala's notion of visibility to Java's apply: we cannot emit PROTECTED methods in interfaces on the JVM, but knowing that these trait methods are protected means we won't emit static forwarders.

    JVMS: "Methods of interfaces may have any of the flags in Table 4.6-A set except ACC_PROTECTED, ACC_FINAL, ACC_SYNCHRONIZED, and ACC_NATIVE (JLS §9.4)."

    TODO: can we just set the right flags from the start?? could we use the final flag to indicate a private method is really-really-private?

48.  def publicizeTraitMethods(clazz: Global.Symbol): Unit
49.  val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent
50.  val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent
51.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
52.  val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent
53.  def toString(): String
    Definition Classes
      AnyRef → Any
54.  def transformInfo(sym: Global.Symbol, tp: Global.Type): Global.Type
    Definition Classes
      Mixin → InfoTransform
55.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
56.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
57.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
58.  def →[B](y: B): (Mixin, B)
    Implicit
      This member is added by an implicit conversion from Mixin to ArrowAssoc[Mixin] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
59.  object NeedStaticImpl extends Global.PlainAttachment with Product with Serializable

### Inherited from AccessorSynthesis

### Inherited from TreeDSL

### Inherited from InfoTransform

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Mixin to any2stringadd[Mixin]

### Inherited by implicit conversion StringFormat from Mixin to StringFormat[Mixin]

### Inherited by implicit conversion Ensuring from Mixin to Ensuring[Mixin]

### Inherited by implicit conversion ArrowAssoc from Mixin to ArrowAssoc[Mixin]

### Ungrouped